package cn.com.infosec.asn1;

import java.io.IOException;
import java.util.Enumeration;

class LazyDERConstructionEnumeration implements Enumeration {
   private ASN1InputStream aIn;
   private Object nextObj;

   public LazyDERConstructionEnumeration(byte[] encoded) {
      this.aIn = new ASN1InputStream(encoded, true);
      this.nextObj = this.readObject();
   }

   private Object readObject() {
      try {
         return this.aIn.readObject();
      } catch (IOException var1) {
         throw new IllegalStateException("malformed DER construction: " + var1);
      }
   }

   public boolean hasMoreElements() {
      return this.nextObj != null;
   }

   public Object nextElement() {
      Object var10000 = this.nextObj;
      this.nextObj = this.readObject();
      return var10000;
   }
}
